<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="auto"
      v-loading="formLoading"
    >
      <el-form-item :label="t('ProductionPlan.FormingRecord.dialogTeamLabel')" prop="workTeamId">
        <el-input v-model="formData.workTeamId" :placeholder="t('ProductionPlan.FormingRecord.dialogTeamPlaceholder')" />
      </el-form-item>
      <el-form-item :label="t('ProductionPlan.FormingRecord.dialogOrganizationLabel')" prop="organizationId">
        <el-input v-model="formData.organizationId" :placeholder="t('ProductionPlan.FormingRecord.dialogOrganizationPlaceholder')" />
      </el-form-item>
      <el-form-item :label="t('ProductionPlan.FormingRecord.dialogMachineLabel')" prop="machineId">
        <el-input v-model="formData.machineId" :placeholder="t('ProductionPlan.FormingRecord.dialogMachinePlaceholder')" />
      </el-form-item>

      <el-form-item :label="t('ProductionPlan.FormingRecord.dialogStartTimeLabel')" prop="startTime">
        <el-date-picker
          v-model="formData.startTime"
          type="date"
          value-format="x"
          :placeholder="t('ProductionPlan.FormingRecord.dialogStartTimePlaceholder')"
        />
      </el-form-item>
      <el-form-item :label="t('ProductionPlan.FormingRecord.dialogEndTimeLabel')" prop="endTime">
        <el-date-picker
          v-model="formData.endTime"
          type="date"
          value-format="x"
          :placeholder="t('ProductionPlan.FormingRecord.dialogEndTimePlaceholder')"
        />
      </el-form-item>
      <el-form-item :label="t('ProductionPlan.FormingRecord.dialogStatusLabel')" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio
            v-for="dict in getIntDictOptions(DICT_TYPE.MES_RECORD_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item :label="t('ProductionPlan.FormingRecord.dialogProcessLabel')" prop="recordType">
        <el-select v-model="formData.recordType" :placeholder="t('ProductionPlan.FormingRecord.dialogProcessPlaceholder')">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_ORG_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item :label="t('ProductionPlan.FormingRecord.dialogRemarkLabel')" prop="remark">
        <el-input v-model="formData.remark" :placeholder="t('ProductionPlan.FormingRecord.dialogRemarkPlaceholder')" />
      </el-form-item>

    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('ProductionPlan.FormingRecord.dialogSubmitButtonText') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('ProductionPlan.FormingRecord.dialogCancelButtonText') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, getStrDictOptions, getBoolDictOptions, DICT_TYPE } from '@/utils/dict'
import { RecordTemplateApi, RecordTemplateVO } from '@/api/mes/record'

/** 记录表 表单 */
defineOptions({ name: 'RecordTemplateForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  organizationId: undefined,
  machineId: undefined,
  workTeamId: undefined,
  startTime: undefined,
  endTime: undefined,
  groupManagerApproveId1: undefined,
  groupManagerApproveId2: undefined,
  productionManagerApproveId1: undefined,
  productionManagerApproveId2: undefined,
  processInstanceId: undefined,
  status: undefined,
  recordType: undefined,
  remark: undefined,
  isEnable: undefined,
})
const formRules = reactive({
  organizationId: [{ required: true, message: t('ProductionPlan.FormingRecord.validatorOrganizationRequired'), trigger: 'blur' }],
  startTime: [{ required: true, message: t('ProductionPlan.FormingRecord.validatorStartTimeRequired'), trigger: 'blur' }],
  endTime: [{ required: true, message: t('ProductionPlan.FormingRecord.validatorEndTimeRequired'), trigger: 'blur' }],
  recordType: [{ required: true, message: t('ProductionPlan.FormingRecord.validatorProcessRequired'), trigger: 'change' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await RecordTemplateApi.getRecordTemplate(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as RecordTemplateVO
    if (formType.value === 'create') {
      await RecordTemplateApi.createRecordTemplate(data)
      message.success(t('common.createSuccess'))
    } else {
      await RecordTemplateApi.updateRecordTemplate(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    organizationId: undefined,
    machineId: undefined,
    workTeamId: undefined,
    startTime: undefined,
    endTime: undefined,
    groupManagerApproveId1: undefined,
    groupManagerApproveId2: undefined,
    productionManagerApproveId1: undefined,
    productionManagerApproveId2: undefined,
    processInstanceId: undefined,
    status: undefined,
    recordType: undefined,
    remark: undefined,
    isEnable: undefined,
  }
  formRef.value?.resetFields()
}
</script>
